=== modified file 'NEWS'
--- NEWS	2007-05-10 05:55:01 +0000
+++ NEWS	2007-05-21 11:36:38 +0000
@@ -8,6 +8,10 @@
       that we can pass in the Transport that we already have.
       (John Arbash Meinel, #75721)
 
+    * ``DirState.set_state_from_inventory()`` needs to properly order
+      based on split paths, not just string paths.
+      (John Arbash Meinel, #115947)
+
 
 bzr 0.16  2007-05-07
   

=== modified file 'bzrlib/dirstate.py'
--- bzrlib/dirstate.py	2007-04-21 14:39:50 +0000
+++ bzrlib/dirstate.py	2007-05-21 11:36:38 +0000
@@ -1986,7 +1986,8 @@
                 # both sides are dealt with, move on
                 current_old = advance(old_iterator)
                 current_new = advance(new_iterator)
-            elif new_entry_key < current_old[0]:
+            elif (new_entry_key[0].split('/') < current_old[0][0].split('/')
+                  and new_entry_key[1:] < current_old[0][1:]):
                 # new comes before:
                 # add a entry for this and advance new
                 self.update_minimal(new_entry_key, current_new_minikind,

